#define _XOPEN_SOURCE	// strptime
#include <stdio.h>
#include <libgen.h>	// basename
#include <libgyim.h>	// filenyit
#include <time.h>
#include <string.h>
#include <unistd.h>	// param. atvetel

//#define	DEBUG	2	// hany sort irjunk ki teszteleskor
static int OT = 5;	// a logsor elejere tesszuk a 4-betus evet es egy helykozt NORMAL datumtipusnal
static enum enumstr { NORMAL, APACHE } idotip = NORMAL;


		// Egy sor kiirasa 
static void egysor(char *sor, time_t tol, time_t most)	// egy sor ki(nem)irasa
{
struct tm dat;	// az akt. rekordbeli ido
time_t ido;	// az akt. rekordbeli ido osszehasonlithato alakban
int ora = 0, perc = 0;
char *mut;

switch(idotip)
	{
	case NORMAL:
		if(strptime(sor,"%Y %b %d %T",&dat) == NULL)
			return;		// idokonverzios hiba
		dat.tm_isdst = -1;
		break;
	case APACHE:
		mut = sor + strcspn(sor,"[");
		if(*mut++ != '[' || strptime(mut,"%d/%b/%Y:%T",&dat) == NULL)
			return;		// nem talaltunk [-et a sorban
		mut += strcspn(mut," ");
		if(*mut++ != ' ' || sscanf(mut,"%3d%2d",&ora,&perc) < 2)
			return;		// nem talaltunk +oopp-t.
		if(ora < 0)
			perc = -perc;
#ifdef	DEBUG
		printf("locale = %02d%02d\n",ora,perc);
#endif
		dat.tm_isdst = 0;
		break;
	default: return;
	}
#ifdef	DEBUG
fputs(sor,stdout);
#endif
ido = mktime(&dat);
if(ido == (time_t)-1)
	return;		// valami gaz van az idokonvertalassal
ido += 60*ora + perc;	// korrigalunk a helyi idovel
#ifdef	DEBUG
printf("tol=%lld, dat=%lld, kul=%ld\n\n",(long long)tol, (long long)ido, (long)(ido-tol));
#endif
if(ido >= tol && ido < most + 60)
	fputs(sor+OT,stdout);	// a sor elejet a foprogram toltotte fel
}


int main(int argc, char *argv[])
{
FILE *fp;	// 1. param
int ido;	// 2. param (sec)
time_t tol;	// ettol kezdve irjuk ki a logot.
time_t most;	// a program inditasanak idopontja
struct tm *evstr;	// csak az ev kell belole
char sor[1000];	// A logsorok helye
#ifdef	DEBUG
int i = 0;
#endif
static const char kapcs[] = "ah";
struct flagstr {
        int help:1;
        } flag;
int c;

flag.help = 0;
while( (c=getopt(argc,argv,kapcs)) >= 0)
        {
        switch(c)
                {
		case 'a': idotip = APACHE;
			OT = 0;		// nem kell ev a sor elejere
			break;
                case 'h': flag.help = 1;
                        break;
                }
        }


		// Parameterbeolvasas
if(argc < 2 || flag.help)
	{
	fprintf(stderr,"Hivas: %s logfile [ ido ]\nA logfile alakja: Jan 11 07:02:30...\n"
		"A -a kapcsoloval a logfile alakja: ...[nap/ho/ev:ora:perc:sec]... (apache alak)\n"
		"A masodik parameterben az ido masodpercben.\n"
		"Az utolso ido-nyi sorokat irja ki az aktualis idohoz kepest",basename(argv[0]));
	return 1;
	}
fp = strcmp(argv[optind],"-")? filenyit(argv[optind],"r"): stdin;
if(argc >= 3)
	{
	sscanf(argv[optind+1],"%d",&ido);
	if(ido <= 0)
		{
		fputs("A masodik parameter hibas\n",stderr);
		return 1;
		}
	}
else	ido = 3600;
#ifdef	DEBUG
printf("%s-t megnyitottam. ido = %d\n",argv[optind],ido);	// a parameterek fp-ben es ido-ben
#endif

		// Az aktualis ido beolvasasa kov.
most = time(NULL);
tol = most - ido;		// az ennel regebbi sorokat eldobjuk, a tobbit kiirjuk
evstr = gmtime(&tol);
sprintf(sor,"%4d ",evstr->tm_year+1900);	// az ev nincs a logban. Beletesszuk. Evvaltaskor gaz van.

		// Kezdjuk az olvasast
while(fgets(sor+OT,sizeof(sor)-OT,fp) != NULL)
	{
	egysor(sor,tol,most);
#ifdef	DEBUG
	if(++i >= DEBUG)
		break;
	else	puts("");
#endif
	}

		// Program vege
fclose(fp);
return 0;
}
